package delete

import (
	"encoding/json"
	"fmt"
	"os"

	"gitlab.com/gitlab-org/ci-cd/shared-runners/images/aws/grit-images/pkg/aws_util"
	"gitlab.com/gitlab-org/ci-cd/shared-runners/images/aws/grit-images/pkg/delete"
	"gitlab.com/gitlab-org/ci-cd/shared-runners/images/aws/grit-images/pkg/types"

	"github.com/urfave/cli/v2"
)

var DeleteAMIsFromAMIListFileCMD = &cli.Command{
	Name:   "delete-amis-from-list",
	Usage:  "delete all AMIs that are no longer supported. The list is generated by the daily-drift-check job.",
	Action: DeleteAMIsFromAMIListFile,
	Flags: []cli.Flag{
		&cli.StringFlag{
			Name:  "amis-to-delete",
			Usage: "Path at which the list of AMIs to delete has been generated.",
		},
		&cli.BoolFlag{
			Name:  "dryrun",
			Usage: "If set, only output which AMIs would be deleted.",
		},
	},
}

func DeleteAMIsFromAMIListFile(ctx *cli.Context) error {
	amisToDeleteFile := ctx.String("amis-to-delete")
	dryrun := ctx.Bool("dryrun")
	amiListFile, err := loadResults(amisToDeleteFile)
	if err != nil {
		return err
	}

	regions := make(map[types.Region][]types.AMI, 0)
	for _, ami := range amiListFile.AMIs {
		regions[ami.Region] = append(regions[ami.Region], ami)
	}

	if dryrun {
		fmt.Println("Dry run: Would delete following AMIs")
	}
	for region, amis := range regions {
		svc, err := aws_util.NewClient(string(region))
		if err != nil {
			return err
		}

		for _, ami := range amis {
			if dryrun {
				fmt.Println(ami.Id, ami.Region)
				continue
			}
			err := delete.DeleteAMIAndSnapshot(svc, ami.Id)
			if err != nil {
				return err
			}
		}
	}

	return nil
}

func loadResults(amisListFilePath string) (types.AMIListFile, error) {
	var amiListFile types.AMIListFile

	// Read the file content
	amisJSON, err := os.ReadFile(amisListFilePath)
	if err != nil {
		return amiListFile, fmt.Errorf("error reading file %v: %v", amisListFilePath, err)
	}

	// Unmarshal JSON into the struct
	err = json.Unmarshal(amisJSON, &amiListFile)
	if err != nil {
		return amiListFile, fmt.Errorf("error unmarshalling JSON: %v", err)
	}

	return amiListFile, nil
}
